unit spi;

interface
type
    mode  = ( mode0, mode3, reset );
    order = ( lsb, msb );
var
    data : byte    absolute $F9; volatile;
    free : boolean absolute $FB; volatile;

procedure master ( mode : mode; order : order; prescaler : byte );

implementation
var
    spi0_ck_se : byte absolute $FB; volatile;
    spi0_ctrl  : byte absolute $FA; volatile;
    spi0_setup : byte absolute $FC; volatile;

procedure master;
begin
    spi0_ck_se := prescaler;
    case order of
        lsb : spi0_setup := {bit_order} 8;
        msb : spi0_setup := 0;
    end;
    case mode of
        mode0 : spi0_ctrl := {mosi_oe sck_oe} $60;
        mode3 : spi0_ctrl := {mosi_oe sck_oe mst_clk} $68;
        reset : spi0_ctrl := {clr_all} 2;
    end;
end;

end.
