; Turbo51 version 0.1.3.17, Copyright 2000 - 2013 Igor Funa

$REGISTERBANK (0)

_CODE         SEGMENT  CODE
_CONST        SEGMENT  CODE
_DATA         SEGMENT  DATA
_XDATA        SEGMENT  XDATA
_BIT          SEGMENT  BIT

              PUBLIC   baud
              PUBLIC   t2mod
              PUBLIC   rbuf
              PUBLIC   tbuf
              PUBLIC   rin
              PUBLIC   rout
              PUBLIC   tin
              PUBLIC   tout
              PUBLIC   tmp
              PUBLIC   zlf

              PUBLIC   lf
              PUBLIC   poll
              PUBLIC   rate
              PUBLIC   read
              PUBLIC   write
              PUBLIC   uart

              EXTRN    DATA  (SystemIO)

              EXTRN    CODE  (sysLoad_Long0_From_IDATA)
              EXTRN    CODE  (sysLoad_Long1_From_CODE)
              EXTRN    CODE  (sysLongComparison)
              EXTRN    CODE  (sysLoad_Long0_From_CODE)
              EXTRN    CODE  (sysLoad_Long1_From_IDATA)
              EXTRN    CODE  (sysLongDivision)

; unit uart;
; {$xdata}
; 
; interface
; 
; function lf : boolean;

RSEG _BIT

lf_Result:                      DBIT     1

; procedure poll; usingany;
; procedure rate ( baud : longint );

RSEG _DATA

baud:                           DS       4

; 
; implementation
; const

RSEG _CONST

;     rmask = $FF;
;     tmask = $3F;
; var
;     t2mod : byte absolute $C9; volatile;
t2mod                           EQU      $C9

;     rbuf : array [0..rmask] of byte xdata;

RSEG _XDATA

rbuf:                           DS       256

;     tbuf : array [0..tmask] of byte xdata;
tbuf:                           DS       64

;     rin, rout, tin, tout, tmp : byte;

RSEG _DATA

rin:                            DS       1
rout:                           DS       1
tin:                            DS       1
tout:                           DS       1
tmp:                            DS       1

;     zlf : boolean;

RSEG _BIT

zlf:                            DBIT     1

; 
; function lf;
; var
;     i : byte;

RSEG _DATA

i:                              DS       1

USING 0

lf:
; begin
;     i := rout;
              MOV       R2, rout

;     result := false;
              CLR       lf_Result

;     while i <> rin do begin
              SJMP      L_0018
L_0006:

;         if rbuf[i] = system.lf then begin
              ADD       A, #LOW  (rbuf)
              MOV       DPL, A
              CLR       A
              ADDC      A, #HIGH (rbuf)
              MOV       DPH, A
              MOVX      A, @DPTR
              CJNE      A, #$0A, L_0017

;             result := true;
              SETB      lf_Result

;             break;
              SJMP      L_001C

;         end;
L_0017:
;         i := (i + 1) and rmask;
              INC       R2

;     end;
L_0018:
;     while i <> rin do begin
              MOV       A, R2
              CJNE      A, rin, L_0006
L_001C:

; end;
              MOV       C, lf_Result
              RET

; 
; procedure poll;

poll:
; begin
;     if ri then begin
              JNB       SCON.0, L_0034

;         ri := false;
              CLR       SCON.0

;         rbuf[rin] := sbuf;
              MOV       A, rin
              ADD       A, #LOW  (rbuf)
              MOV       DPL, A
              CLR       A
              ADDC      A, #HIGH (rbuf)
              MOV       DPH, A
              MOV       A, SBUF
              MOVX      @DPTR, A

;         rin := (rin + 1) and rmask;
              INC       rin

;     end;
L_0034:
;     if (tin <> tout) and ti then begin
              MOV       A, tin
              XRL       A, tout
              JZ        L_0054
              JNB       SCON.1, L_0054

;         ti := false;
              CLR       SCON.1

;         sbuf := tbuf[tout];
              MOV       A, tout
              ADD       A, #LOW  (tbuf)
              MOV       DPL, A
              CLR       A
              ADDC      A, #HIGH (tbuf)
              MOV       DPH, A
              MOVX      A, @DPTR
              MOV       SBUF, A

;         tout := (tout + 1) and tmask;
              MOV       A, tout
              INC       A
              ANL       A, #$3F
              MOV       tout, A

;     end;
L_0054:
; end;
              RET

; 
; procedure rate;

RSEG _CONST

C_0000:                         DB        070H, 017H, 0, 0            ; $00001770 = 6000
C_0004:                         DB        060H, 0E3H, 016H, 0         ; $0016E360 = 1500000
C_0008:                         DB        0F4H, 1, 0, 0               ; $000001F4 = 500
C_000C:                         DB        048H, 0E8H, 1, 0            ; $0001E848 = 125000

rate:
; begin
;     scon := 0;
              MOV       SCON, #0

;     if baud > 6000 then begin
              MOV       R0, #baud
              LCALL     sysLoad_Long0_From_IDATA
              MOV       DPTR, #C_0000
              LCALL     sysLoad_Long1_From_CODE
              SETB      C
              LCALL     sysLongComparison
              JC        L_0081

;         t2mod := t2mod or {tmr_clk t1_clk} $A0;
              ORL       $C9, #$A0

;         th1 := -byte( 1500000 div baud );
              MOV       DPTR, #C_0004
              LCALL     sysLoad_Long0_From_CODE
              MOV       R0, #baud
              LCALL     sysLoad_Long1_From_IDATA
              LCALL     sysLongDivision
              MOV       A, R2
              CPL       A
              INC       A
              MOV       TH1, A

;     end else if baud > 500 then begin
              SJMP      L_00A8
L_0081:
              MOV       R0, #baud
              LCALL     sysLoad_Long0_From_IDATA
              MOV       DPTR, #C_0008
              LCALL     sysLoad_Long1_From_CODE
              SETB      C
              LCALL     sysLongComparison
              JC        L_00A8

;         t2mod := t2mod and (not {t1_clk} $20);
              ANL       $C9, #$DF

;         th1 := -byte( 125000 div baud );
              MOV       DPTR, #C_000C
              LCALL     sysLoad_Long0_From_CODE
              MOV       R0, #baud
              LCALL     sysLoad_Long1_From_IDATA
              LCALL     sysLongDivision
              MOV       A, R2
              CPL       A
              INC       A
              MOV       TH1, A

;     end;
L_00A8:
;     tl1 := $FF;
              MOV       TL1, #$FF

;     scon := {sm1 ren ti} $52;
              MOV       SCON, #$52

; end;
              RET

; 
; function read : byte;

RSEG _DATA

read_Result:                    DS       1

read:
; begin
;     if zlf then begin
              JNB       zlf, L_00B9

;         zlf := false;
              CLR       zlf

;         tmp := system.lf;
              MOV       tmp, #$0A

;     end else if rin = rout then begin
              SJMP      L_00D5
L_00B9:
              MOV       A, rin
              CJNE      A, rout, L_00C5

;         zlf := true;
              SETB      zlf

;         tmp := 0;
              MOV       tmp, #0

;     end else begin
              SJMP      L_00D5
L_00C5:

;         tmp := rbuf[rout];
              MOV       A, rout
              ADD       A, #LOW  (rbuf)
              MOV       DPL, A
              CLR       A
              ADDC      A, #HIGH (rbuf)
              MOV       DPH, A
              MOVX      A, @DPTR
              MOV       tmp, A

;         rout := (rout + 1) and rmask;
              INC       rout

;     end;
L_00D5:
;     result := tmp;
; end;
              MOV       A, tmp
              RET

; 
; procedure write;

write:
; begin
;     asm mov tmp, a end;
              MOV       tmp, A

;     tbuf[tin] := tmp;
              MOV       A, tin
              ADD       A, #LOW  (tbuf)
              MOV       DPL, A
              CLR       A
              ADDC      A, #HIGH (tbuf)
              MOV       DPH, A
              MOV       A, tmp
              MOVX      @DPTR, A

;     tin := (tin + 1) and tmask;
              MOV       A, tin
              INC       A
              ANL       A, #$3F
              MOV       tin, A

; end;
              RET


uart:
; 
; begin
;     assign( systemio, read, write );
              MOV       SystemIO, #LOW  (write)
              MOV       SystemIO+1, #HIGH (write)
              MOV       SystemIO+2, #LOW  (read)
              MOV       SystemIO+3, #HIGH (read)

;     rin := 0;
              MOV       rin, #0

;     rout := 0;
              MOV       rout, #0

;     tin := 0;
              MOV       tin, #0

;     tout := 0;
              MOV       tout, #0

;     zlf := false;
              CLR       zlf

;     pcon := {smod} $80;
              MOV       PCON, #$80

;     rate( 9600 );
              MOV       baud, #$80
              MOV       baud+1, #$25
              MOV       baud+2, #0
              MOV       baud+3, #0
              LJMP      rate

; end.

RSEG _CONST


              END

