; Turbo51 version 0.1.3.17, Copyright 2000 - 2013 Igor Funa

$REGISTERBANK (0, 2)

_CODE         SEGMENT  CODE
_CONST        SEGMENT  CODE
_DATA         SEGMENT  DATA
_XDATA        SEGMENT  XDATA
_BIT          SEGMENT  BIT

              PUBLIC   device
              PUBLIC   config
              PUBLIC   lang
              PUBLIC   prod
              PUBLIC   serial

              PUBLIC   buf
              PUBLIC   len
              PUBLIC   ok
              PUBLIC   ie_ex
              PUBLIC   ie_usb
              PUBLIC   ip_ex
              PUBLIC   udev_ctrl
              PUBLIC   uep_mod
              PUBLIC   uep0_ctrl
              PUBLIC   uep0_dma
              PUBLIC   uep0_t_len
              PUBLIC   uep1_ctrl
              PUBLIC   uep1_dma
              PUBLIC   uep1_t_len
              PUBLIC   uep2_ctrl
              PUBLIC   uep2_dma
              PUBLIC   uep2_t_len
              PUBLIC   uep3_ctrl
              PUBLIC   uep3_dma
              PUBLIC   uep3_t_len
              PUBLIC   usb_ctrl
              PUBLIC   usb_dev_ad
              PUBLIC   usb_int_en
              PUBLIC   usb_int_fg
              PUBLIC   uif_reset
              PUBLIC   uif_trans
              PUBLIC   usb_int_st
              PUBLIC   usb_rx_len
              PUBLIC   address
              PUBLIC   buf0
              PUBLIC   stage

              PUBLIC   reset
              PUBLIC   trans
              PUBLIC   poll
              PUBLIC   _usb
              PUBLIC   usb

              EXTRN    CODE  (sysCopyFrom_CODE_To_XDATA)

; unit usb;
; {$xdata}
; 
; interface
; var 
;     buf : array [1..3] of record
;         r, t : array [0..63] of byte end xdata; volatile;

RSEG _XDATA

buf:                            DS       384

;     len : array [1..3] of record
;         r, t : byte end; volatile;

RSEG _DATA

len:                            DS       6

;     ok : boolean;

RSEG _BIT

ok:                             DBIT     1

; 
; procedure poll;
; procedure _usb; interrupt $43; using 2;
; 
; implementation
; const

RSEG _CONST

;     vid = $6666;
;     pid = $5500;
;     rev = $0123;
;     device : array [1..9] of word = (
device:                         
;         $112, $110, 0, $4000, vid, pid, rev, $200, $103
                                DB        012H, 1                     ; $0112 = 274
                                DB        010H, 1                     ; $0110 = 272
                                DB        0, 0                        ; $0000 = 0
                                DB        0, 040H                     ; $4000 = 16384
                                DB        066H, 066H                  ; $6666 = 26214
                                DB        0, 055H                     ; $5500 = 21760
                                DB        023H, 1                     ; $0123 = 291
                                DB        0, 2                        ; $0200 = 512

;         );
                                DB        3, 1                        ; $0103 = 259

;     config : array [1..60] of byte = (
config:                         
;         9, 2, 60,0, 1, 1, 0, $80, 100,
                                DB        9                           ; $09 = 9
                                DB        2                           ; $02 = 2
                                DB        $3C                         ; $3C = 60
                                DB        0                           ; $00 = 0
                                DB        1                           ; $01 = 1
                                DB        1                           ; $01 = 1
                                DB        0                           ; $00 = 0
                                DB        $80                         ; $80 = 128
                                DB        $64                         ; $64 = 100

;         9, 4, 0, 0, 6, $FF, 0, 0, 0,
                                DB        9                           ; $09 = 9
                                DB        4                           ; $04 = 4
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0
                                DB        6                           ; $06 = 6
                                DB        $FF                         ; $FF = 255
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5, $81, 2, 64,0, 0,
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        $81                         ; $81 = 129
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5,   1, 2, 64,0, 0,
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        1                           ; $01 = 1
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5, $82, 2, 64,0, 0,
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        $82                         ; $82 = 130
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5,   2, 2, 64,0, 0,
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        2                           ; $02 = 2
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5, $83, 2, 64,0, 0,
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        $83                         ; $83 = 131
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0
                                DB        0                           ; $00 = 0

;         7, 5,   3, 2, 64,0, 0
                                DB        7                           ; $07 = 7
                                DB        5                           ; $05 = 5
                                DB        3                           ; $03 = 3
                                DB        2                           ; $02 = 2
                                DB        $40                         ; $40 = 64
                                DB        0                           ; $00 = 0

;         );
                                DB        0                           ; $00 = 0

;     lang   : array [1..4]  of byte = ( 4, 3, 9,4 );
lang:                           DB        4                           ; $04 = 4
                                DB        3                           ; $03 = 3
                                DB        9                           ; $09 = 9
                                DB        4                           ; $04 = 4

;     prod   : array [1..12] of byte = ( 12, 3, 90,0, 97,0, 100,0, 105,0, 103,0 );
prod:                           DB        $0C                         ; $0C = 12
                                DB        3                           ; $03 = 3
                                DB        $5A                         ; $5A = 90
                                DB        0                           ; $00 = 0
                                DB        $61                         ; $61 = 97
                                DB        0                           ; $00 = 0
                                DB        $64                         ; $64 = 100
                                DB        0                           ; $00 = 0
                                DB        $69                         ; $69 = 105
                                DB        0                           ; $00 = 0
                                DB        $67                         ; $67 = 103
                                DB        0                           ; $00 = 0

;     serial : array [1..12] of byte = ( 12, 3, 49,0, 50,0, 51,0, 52,0, 53,0 );
serial:                         DB        $0C                         ; $0C = 12
                                DB        3                           ; $03 = 3
                                DB        $31                         ; $31 = 49
                                DB        0                           ; $00 = 0
                                DB        $32                         ; $32 = 50
                                DB        0                           ; $00 = 0
                                DB        $33                         ; $33 = 51
                                DB        0                           ; $00 = 0
                                DB        $34                         ; $34 = 52
                                DB        0                           ; $00 = 0
                                DB        $35                         ; $35 = 53
                                DB        0                           ; $00 = 0

; var
;     ie_ex      : byte absolute $E8; volatile;
ie_ex                           EQU      $E8

;     ie_usb     : boolean absolute ie_ex.2;
ie_usb                          BIT      $E8.2

;     ip_ex      : byte absolute $E9; volatile;
ip_ex                           EQU      $E9

;     udev_ctrl  : byte absolute $D1; volatile;
udev_ctrl                       EQU      $D1

;     uep_mod    : word absolute $EA; volatile;
uep_mod                         EQU      $EA

;     uep0_ctrl  : byte absolute $DC; volatile;
uep0_ctrl                       EQU      $DC

;     uep0_dma   : word absolute $EC; volatile;
uep0_dma                        EQU      $EC

;     uep0_t_len : byte absolute $DD; volatile;
uep0_t_len                      EQU      $DD

;     uep1_ctrl  : byte absolute $D2; volatile;
uep1_ctrl                       EQU      $D2

;     uep1_dma   : word absolute $EE; volatile;
uep1_dma                        EQU      $EE

;     uep1_t_len : byte absolute $D3; volatile;
uep1_t_len                      EQU      $D3

;     uep2_ctrl  : byte absolute $D4; volatile;
uep2_ctrl                       EQU      $D4

;     uep2_dma   : word absolute $E4; volatile;
uep2_dma                        EQU      $E4

;     uep2_t_len : byte absolute $D5; volatile;
uep2_t_len                      EQU      $D5

;     uep3_ctrl  : byte absolute $D6; volatile;
uep3_ctrl                       EQU      $D6

;     uep3_dma   : word absolute $E6; volatile;
uep3_dma                        EQU      $E6

;     uep3_t_len : byte absolute $D7; volatile;
uep3_t_len                      EQU      $D7

;     usb_ctrl   : byte absolute $E2; volatile;
usb_ctrl                        EQU      $E2

;     usb_dev_ad : byte absolute $E3; volatile;
usb_dev_ad                      EQU      $E3

;     usb_int_en : byte absolute $E1; volatile;
usb_int_en                      EQU      $E1

;     usb_int_fg : byte absolute $D8; volatile;
usb_int_fg                      EQU      $D8

;     uif_reset  : boolean absolute usb_int_fg.0;
uif_reset                       BIT      $D8.0

;     uif_trans  : boolean absolute usb_int_fg.1;
uif_trans                       BIT      $D8.1

;     usb_int_st : byte absolute $D9; volatile;
usb_int_st                      EQU      $D9

;     usb_rx_len : byte absolute $DB; volatile;
usb_rx_len                      EQU      $DB

;     address : byte;

RSEG _DATA

address:                        DS       1

;     buf0 : array [0..31] of word xdata; volatile;

RSEG _XDATA

buf0:                           DS       64

;     stage : ( setup, data, status );

RSEG _DATA

stage:                          DS       1

; 
; procedure reset; usingany;

USING 0

reset:
; begin
;     address := 0;
              MOV       address, #0

;     len[1].r := 0; len[1].t := 0;
              MOV       len, #0
              MOV       len+1, #0

;     len[2].r := 0; len[2].t := 0;
              MOV       len+2, #0
              MOV       len+3, #0

;     len[3].r := 0; len[3].t := 0;
              MOV       len+4, #0
              MOV       len+5, #0

;     ok := false;
              CLR       ok

;     stage := setup;
              MOV       stage, #0

;     uep0_ctrl := {r-nak t-nak} $A;
              MOV       $DC, #$0A

;     uep1_ctrl := {r-auto t-auto r-nak t-nak} $3A;
              MOV       $D2, #$3A

;     uep2_ctrl := {r-auto t-auto r-nak t-nak} $3A;
              MOV       $D4, #$3A

;     uep3_ctrl := {r-auto t-auto r-nak t-nak} $3A;
              MOV       $D6, #$3A

;     usb_dev_ad := 0;
              MOV       $E3, #0

;     uif_reset := false;
              CLR       $D8.0

;     uif_trans := false;
              CLR       $D8.1

; end;
              RET

; 
; procedure trans; usingany;
; var
;     len0 : byte;
len0:                           DS       1

trans:
; begin
;     case usb_int_st and $3F of
              MOV       A, $D9
              ANL       A, #$3F
              MOV       R2, A

;         {setup} $30 : begin
              XRL       A, #$30
              JZ        L_003A
              LJMP      L_0184
L_003A:

;             len0 := byte( buf0[3] );
              MOV       DPTR, #buf0+6
              MOVX      A, @DPTR
              MOV       R6, A

;             stage := setup;
              MOV       stage, #0

;             case buf0[0] of
              MOV       DPTR, #buf0
              MOVX      A, @DPTR
              MOV       R2, A
              INC       DPTR
              MOVX      A, @DPTR
              MOV       R3, A

;                 {get descriptor} $680 : case buf0[1] of
              MOV       A, R2
              XRL       A, #$80
              JZ        L_0052
              LJMP      L_00E1
L_0052:
              MOV       A, R3
              XRL       A, #6
              JZ        L_005A
              LJMP      L_00E1
L_005A:
              INC       DPTR
              MOVX      A, @DPTR
              MOV       R2, A
              INC       DPTR
              MOVX      A, @DPTR

;                     {device} $100 : begin
              CJNE      R2, #0, L_0079
              CJNE      A, #1, L_0079

;                         move( device, buf0, sizeof( device ) );
              MOV       R2, #LOW  (buf0)
              MOV       R3, #HIGH (buf0)
              MOV       DPTR, #device
              MOV       R4, #LOW  ($0012)
              MOV       R5, #HIGH ($0012)
              LCALL     sysCopyFrom_CODE_To_XDATA

;                         stage := data;
              MOV       stage, #1

;                     end;
              LJMP      L_0161
L_0079:

;                     {configuration} $200 : begin
              CJNE      R2, #0, L_0093
              CJNE      A, #2, L_0093

;                         move( config, buf0, sizeof( config ) );
              MOV       R2, #LOW  (buf0)
              MOV       R3, #HIGH (buf0)
              MOV       DPTR, #config
              MOV       R4, #LOW  ($003C)
              MOV       R5, #HIGH ($003C)
              LCALL     sysCopyFrom_CODE_To_XDATA

;                         stage := data;
              MOV       stage, #1

;                     end;
              LJMP      L_0161
L_0093:

;                     {language} $300 : begin
              CJNE      R2, #0, L_00AD
              CJNE      A, #3, L_00AD

;                         move( lang, buf0, sizeof( lang ) );
              MOV       R2, #LOW  (buf0)
              MOV       R3, #HIGH (buf0)
              MOV       DPTR, #lang
              MOV       R4, #LOW  (4)
              MOV       R5, #HIGH (4)
              LCALL     sysCopyFrom_CODE_To_XDATA

;                         stage := data;
              MOV       stage, #1

;                     end;
              LJMP      L_0161
L_00AD:

;                     {product} $302 : begin
              CJNE      R2, #2, L_00C7
              CJNE      A, #3, L_00C7

;                         move( prod, buf0, sizeof( prod ) );
              MOV       R2, #LOW  (buf0)
              MOV       R3, #HIGH (buf0)
              MOV       DPTR, #prod
              MOV       R4, #LOW  ($000C)
              MOV       R5, #HIGH ($000C)
              LCALL     sysCopyFrom_CODE_To_XDATA

;                         stage := data;
              MOV       stage, #1

;                     end;
              LJMP      L_0161
L_00C7:

;                     {serial} $303 : begin
              CJNE      R2, #3, L_00DE
              CJNE      A, #3, L_00DE

;                         move( serial, buf0, sizeof( serial ) );
              MOV       R2, #LOW  (buf0)
              MOV       R3, #HIGH (buf0)
              MOV       DPTR, #serial
              MOV       R4, #LOW  ($000C)
              MOV       R5, #HIGH ($000C)
              LCALL     sysCopyFrom_CODE_To_XDATA

;                         stage := data;
              MOV       stage, #1

;                     end;
L_00DE:
              LJMP      L_0161
L_00E1:

;                 end;
;                 {get status} $80, $81, $82,
              CJNE      R2, #$80, L_00E7
              MOV       A, R3
              JZ        L_0101
L_00E7:
              CJNE      R2, #$81, L_00ED
              MOV       A, R3
              JZ        L_0101
L_00ED:
              CJNE      R2, #$82, L_00F3
              MOV       A, R3
              JZ        L_0101
L_00F3:
              CJNE      R2, #$80, L_00FB
              MOV       A, R3
              XRL       A, #8
              JZ        L_0101
L_00FB:
              CJNE      R2, #$81, L_010D
              CJNE      R3, #$0A, L_010D
L_0101:

;                 {get configuration} $880,
;                 {get interface} $A81 : begin
;                     buf0[0] := 0;
              CLR       A
              MOV       DPTR, #buf0
              MOVX      @DPTR, A
              INC       DPTR
              MOVX      @DPTR, A

;                     stage := data;
              MOV       stage, #1

;                 end;
              SJMP      L_0161
L_010D:

;                 {set address} $500 : begin
              CJNE      R2, #0, L_011E
              CJNE      R3, #5, L_011E

;                     address := buf0[1];
              MOV       DPTR, #buf0+2
              MOVX      A, @DPTR
              MOV       address, A

;                     stage := status;
              MOV       stage, #2

;                 end;
              SJMP      L_0161
L_011E:

;                 {clear future} $100, $101, $102,
              CJNE      R2, #0, L_0126
              MOV       A, R3
              XRL       A, #1
              JZ        L_015C
L_0126:
              CJNE      R2, #1, L_012E
              MOV       A, R3
              XRL       A, #1
              JZ        L_015C
L_012E:
              CJNE      R2, #2, L_0136
              MOV       A, R3
              XRL       A, #1
              JZ        L_015C
L_0136:
              CJNE      R2, #0, L_013E
              MOV       A, R3
              XRL       A, #3
              JZ        L_015C
L_013E:
              CJNE      R2, #1, L_0146
              MOV       A, R3
              XRL       A, #3
              JZ        L_015C
L_0146:
              CJNE      R2, #2, L_014E
              MOV       A, R3
              XRL       A, #3
              JZ        L_015C
L_014E:
              CJNE      R2, #0, L_0156
              MOV       A, R3
              XRL       A, #9
              JZ        L_015C
L_0156:
              CJNE      R2, #1, L_0161
              CJNE      R3, #$0B, L_0161
L_015C:

;                 {set future}   $300, $301, $302,
;                 {set configuration} $900,
;                 {set interface} $B01 : begin
;                     ok := true;
              SETB      ok

;                     stage := status;
              MOV       stage, #2

;                 end;
L_0161:
;             end;
;             case stage of
              MOV       R2, stage

;                 data : begin
              CJNE      R2, #1, L_0174

;                     if len0 > 63 then len0 := 63;
              MOV       A, R6
              ADD       A, #-64
              JNC       L_016D
              MOV       R6, #$3F
L_016D:

;                     uep0_t_len := len0;
              MOV       $DD, R6

;                     uep0_ctrl := {r-data1 t-data1 r-nak t-ack} $C8;
              MOV       $DC, #$C8

;                 end;
              SJMP      L_0182
L_0174:

;                 status : begin
              CJNE      R2, #2, L_017F

;                     uep0_t_len := 0;
              MOV       $DD, #0

;                     uep0_ctrl := {r-data1 t-data1 r-nak t-ack} $C8;
              MOV       $DC, #$C8

;                 end;
              SJMP      L_0182
L_017F:

;                 else uep0_ctrl := {r-stall t-stall} $F;
              MOV       $DC, #$0F
L_0182:

;             end;
;         end;
              SJMP      L_01FC
L_0184:

;         {out0} 0 : case stage of
              CJNE      R2, #0, L_0199

;             status : begin
              MOV       A, stage
              CJNE      A, #2, L_0194

;                 uep0_ctrl := {r-nak t-nak} $A;
              MOV       $DC, #$0A

;                 stage := setup;
              MOV       stage, #0

;             end;
              SJMP      L_01FC
L_0194:

;             else uep0_ctrl := {r-stall t-stall} $F;
              MOV       $DC, #$0F
              SJMP      L_01FC
L_0199:

;         end;
;         {in0} $20 : case stage of
              CJNE      R2, #$20, L_01BC
              MOV       R2, stage

;             data : begin
              CJNE      R2, #1, L_01A9

;                 uep0_ctrl := {r-data1 t-data1 r-ack t-nak} $C2;
              MOV       $DC, #$C2

;                 stage := status;
              MOV       stage, #2

;             end;
              SJMP      L_01FC
L_01A9:

;             status : begin
              CJNE      R2, #2, L_01B7

;                 usb_dev_ad := address;
              MOV       $E3, address

;                 uep0_ctrl := {r-nak t-nak} $A;
              MOV       $DC, #$0A

;                 stage := setup;
              MOV       stage, #0

;             end;
              SJMP      L_01FC
L_01B7:

;             else uep0_ctrl := {r-stall t-stall} $F;
              MOV       $DC, #$0F
              SJMP      L_01FC
L_01BC:

;         end;
;         {out1} 1 : begin
              CJNE      R2, #1, L_01C7

;             {r-nak} uep1_ctrl := uep1_ctrl or 8;
              ORL       $D2, #8

;             len[1].r := usb_rx_len;
              MOV       len, $DB

;         end;
              SJMP      L_01FC
L_01C7:

;         {in1} $21 : begin
              CJNE      R2, #$21, L_01D2

;             {t-nak} uep1_ctrl := uep1_ctrl or 2;
              ORL       $D2, #2

;             len[1].t := 0;
              MOV       len+1, #0

;         end;
              SJMP      L_01FC
L_01D2:

;         {out2} 2 : begin
              CJNE      R2, #2, L_01DD

;             {r-nak} uep2_ctrl := uep2_ctrl or 8;
              ORL       $D4, #8

;             len[2].r := usb_rx_len;
              MOV       len+2, $DB

;         end;
              SJMP      L_01FC
L_01DD:

;         {in2} $22 : begin
              CJNE      R2, #$22, L_01E8

;             {t-nak} uep2_ctrl := uep2_ctrl or 2;
              ORL       $D4, #2

;             len[2].t := 0;
              MOV       len+3, #0

;         end;
              SJMP      L_01FC
L_01E8:

;         {out3} 3 : begin
              CJNE      R2, #3, L_01F3

;             {r-nak} uep3_ctrl := uep3_ctrl or 8;
              ORL       $D6, #8

;             len[3].r := usb_rx_len;
              MOV       len+4, $DB

;         end;
              SJMP      L_01FC
L_01F3:

;         {in3} $23 : begin
              CJNE      R2, #$23, L_01FC

;             {t-nak} uep3_ctrl := uep3_ctrl or 2;
              ORL       $D6, #2

;             len[3].t := 0;
              MOV       len+5, #0

;         end;
L_01FC:
;     end;
;     uif_trans := false;
              CLR       $D8.1

; end;
              RET

; 
; procedure poll;

poll:
; begin
;     if ((uep1_ctrl and $C) <> 0) and (len[1].r = 0) then begin
              MOV       A, $D2
              ANL       A, #$0C
              JZ        L_020C
              MOV       A, len
              JNZ       L_020C

;         {r-ack} uep1_ctrl := uep1_ctrl and (not $C);
              ANL       $D2, #$F3

;     end;
L_020C:
;     if ((uep1_ctrl and 3) <> 0) and (len[1].t <> 0) then begin
              MOV       A, $D2
              ANL       A, #3
              JZ        L_0225
              MOV       A, len+1
              JZ        L_0225

;         if len[1].t > 64 then len[1].t := 64;
              MOV       A, len+1
              ADD       A, #-65
              JNC       L_021F
              MOV       len+1, #$40
L_021F:

;         uep1_t_len := len[1].t;
              MOV       $D3, len+1

;         {t-ack} uep1_ctrl := uep1_ctrl and (not 3);
              ANL       $D2, #$FC

;     end;
L_0225:
;     if ((uep2_ctrl and $C) <> 0) and (len[2].r = 0) then begin
              MOV       A, $D4
              ANL       A, #$0C
              JZ        L_0232
              MOV       A, len+2
              JNZ       L_0232

;         {r-ack} uep2_ctrl := uep2_ctrl and (not $C);
              ANL       $D4, #$F3

;     end;
L_0232:
;     if ((uep2_ctrl and 3) <> 0) and (len[2].t <> 0) then begin
              MOV       A, $D4
              ANL       A, #3
              JZ        L_024B
              MOV       A, len+3
              JZ        L_024B

;         if len[2].t > 64 then len[2].t := 64;
              MOV       A, len+3
              ADD       A, #-65
              JNC       L_0245
              MOV       len+3, #$40
L_0245:

;         uep2_t_len := len[2].t;
              MOV       $D5, len+3

;         {t-ack} uep2_ctrl := uep2_ctrl and (not 3);
              ANL       $D4, #$FC

;     end;
L_024B:
;     if ((uep3_ctrl and $C) <> 0) and (len[3].r = 0) then begin
              MOV       A, $D6
              ANL       A, #$0C
              JZ        L_0258
              MOV       A, len+4
              JNZ       L_0258

;         {r-ack} uep3_ctrl := uep3_ctrl and (not $C);
              ANL       $D6, #$F3

;     end;
L_0258:
;     if ((uep3_ctrl and 3) <> 0) and (len[3].t <> 0) then begin
              MOV       A, $D6
              ANL       A, #3
              JZ        L_0271
              MOV       A, len+5
              JZ        L_0271

;         if len[3].t > 64 then len[3].t := 64;
              MOV       A, len+5
              ADD       A, #-65
              JNC       L_026B
              MOV       len+5, #$40
L_026B:

;         uep3_t_len := len[3].t;
              MOV       $D7, len+5

;         {t-ack} uep3_ctrl := uep3_ctrl and (not 3);
              ANL       $D6, #$FC

;     end;
L_0271:
;     if not ea then begin
              JB        IE.7, L_0280

;         if uif_reset then reset;
              JNB       $D8.0, L_027A
              LCALL     reset
L_027A:

;         if uif_trans then trans;
              JNB       $D8.1, L_0280
              LCALL     trans

;     end;
L_0280:
; end;
              RET

; 
; procedure _usb;


CSEG AT $0043

USING 2

_usb:
; begin
              PUSH      PSW
              MOV       PSW, #$10
              PUSH      ACC
              PUSH      DPL
              PUSH      DPH

;     if uif_reset then reset;
              JNB       $D8.0, L_0292
              LCALL     reset
L_0292:

;     if uif_trans then trans;
              JNB       $D8.1, L_0298
              LCALL     trans
L_0298:

; end;
              POP       DPH
              POP       DPL
              POP       ACC
              POP       PSW
              RETI


usb:
; 
; begin
;     ie_usb := false;
              CLR       $E8.2

;     usb_ctrl := 0;
              MOV       $E2, #0

;     uep_mod := {3-rt 2-rt 1-rt 4-} $CCC0;
              MOV       $EA, #LOW  ($CCC0)
              MOV       $EB, #HIGH ($CCC0)

;     uep0_dma := word( addr( buf0 ) );
              MOV       $EC, #LOW  (buf0)
              MOV       $ED, #HIGH (buf0)

;     uep1_dma := word( addr( buf[1] ) );
              MOV       $EE, #LOW  (buf)
              MOV       $EF, #HIGH (buf)

;     uep2_dma := word( addr( buf[2] ) );
              MOV       $E4, #LOW  (buf+128)
              MOV       $E5, #HIGH (buf+128)

;     uep3_dma := word( addr( buf[3] ) );
              MOV       $E6, #LOW  (buf+256)
              MOV       $E7, #HIGH (buf+256)

;     reset;
              LCALL     reset

;     udev_ctrl := {pd_dis} $80;
              MOV       $D1, #$80

;     usb_ctrl := {dev_pu_en int_busy dma_en} $29;
              MOV       $E2, #$29

;     udev_ctrl := {pd_dis port_en} $81;
              MOV       $D1, #$81

;     usb_int_en := {trans reset} 3;
              MOV       $E1, #3

;     ip_ex := {ip_usb} 4;
              MOV       $E9, #4

;     ie_usb := true;
              SETB      $E8.2

; end.
              RET

RSEG _CONST


              END

